responses:
  202:
    description: >
      The request was accepted for processing, but processing has not
      been completed. The response shall have an empty payload body.
    headers:
      #TODO: Add headers defined in 4.3.4.3
      Content-Type:
        description: The MIME type of the body of the response.
        type: string
        maximum: 1
        minimum: 1
      Location:
        description: The resource URI of the created VNF instance
        type: string
        format: url
      WWW-Authenticate:
        description: >
          Challenge if the corresponding HTTP request has not provided
          authorization, or error details if the corresponding HTTP
          request has provided an invalid authorization token.
        type: string
        maximum: 1
        minimum: 0
  400:
    description: >
      It fhe request is malformed or syntactically incorrect (e.g. if the
      request URI contains incorrect query parameters or a syntactically
      incorrect payload body), the API producer shall respond with this
      response code. The "ProblemDetails" structure shall be provided,
      and should include in the "detail" attribute more information about
      the source of the problem.
      If the request contains a malformed access token, the API producer
      should respond with this response. The details of the error shall
      be returned in the WWW-Authenticate HTTP header, as defined in
      IETF RFC 6750 [11] and IETF RFC 7235 [16]. The ProblemDetails
      structure may be provided.
      If there is an application error related to the client's input that
      cannot be easily mapped to any other HTTP response code ("catch all
      error"), the API producer shall respond with this response code.The
      "ProblemDetails" structure shall be provided, and shall include in
      the "detail" attribute more information about the source of the
      problem.
    headers:
      Content-Type:
        description: The MIME type of the body of the response.
        type: string
        maximum: 1
        minimum: 1
      WWW-Authenticate:
        description: >
          Challenge if the corresponding HTTP request has not provided
          authorization, or error details if the corresponding HTTP
          request has provided an invalid authorization token.
        type: string
        maximum: 1
        minimum: 0
    schema:
      $ref: "/../definitions/SOL002SOL003_def.yaml#/definitions/ProblemDetails"
  400-attr-based-filtering-error:
    description: >
      Invalid attribute-based filtering parameters or Invalid attribute
      selector.
      It fhe request is malformed or syntactically incorrect (e.g. if the
      request URI contains incorrect query parameters or a syntactically
      incorrect payload body), the API producer shall respond with this
      response code. The "ProblemDetails" structure shall be provided,
      and should include in the "detail" attribute more information about
      the source of the problem.
      If the request contains a malformed access token, the API producer
      should respond with this response. The details of the error shall
      be returned in the WWW-Authenticate HTTP header, as defined in
      IETF RFC 6750 [11] and IETF RFC 7235 [16]. The ProblemDetails
      structure may be provided.
      If there is an application error related to the client's input that
      cannot be easily mapped to any other HTTP response code ("catch all
      error"), the API producer shall respond with this response code.The
      "ProblemDetails" structure shall be provided, and shall include in
      the "detail" attribute more information about the source of the
      problem.
    headers:
      Content-Type:
        description: The MIME type of the body of the response.
        type: string
        maximum: 1
        minimum: 1
      WWW-Authenticate:
        description: >
          Challenge if the corresponding HTTP request has not provided
          authorization, or error details if the corresponding HTTP
          request has provided an invalid authorization token.
        type: string
        maximum: 1
        minimum: 0
    schema:
      $ref: "/../definitions/SOL002SOL003_def.yaml#/definitions/ProblemDetails"
  400-attr-selector:
    description: >
      It fhe request is malformed or syntactically incorrect (e.g. if the
      request URI contains incorrect query parameters or a syntactically
      incorrect payload body), the API producer shall respond with this
      response code. The "ProblemDetails" structure shall be provided,
      and should include in the "detail" attribute more information about
      the source of the problem.
      If the request contains a malformed access token, the API producer
      should respond with this response. The details of the error shall
      be returned in the WWW-Authenticate HTTP header, as defined in
      IETF RFC 6750 [11] and IETF RFC 7235 [16]. The ProblemDetails
      structure may be provided.
      If there is an application error related to the client's input that
      cannot be easily mapped to any other HTTP response code ("catch all
      error"), the API producer shall respond with this response code.The
      "ProblemDetails" structure shall be provided, and shall include in
      the "detail" attribute more information about the source of the
      problem.
    headers:
      Content-Type:
        description: The MIME type of the body of the response.
        type: string
        maximum: 1
        minimum: 1
      WWW-Authenticate:
        description: >
          Challenge if the corresponding HTTP request has not provided
          authorization, or error details if the corresponding HTTP
          request has provided an invalid authorization token.
        type: string
        maximum: 1
        minimum: 0
    schema:
      $ref: "/../definitions/SOL002SOL003_def.yaml#/definitions/ProblemDetails"
  401:
    description: >
      If the request contains no access token even though one is
      required, or if the request contains an authorization token that
      is invalid (e.g. expired or revoked), the API producer should
      respond with this response. The details of the error shall be
      returned in the WWW-Authenticate HTTP header, as defined in
      IETF RFC 6750 [11] and IETF RFC 7235 [16]. The ProblemDetails
      structure may be provided.
    headers:
      Content-Type:
        description: The MIME type of the body of the response.
        type: string
        maximum: 1
        minimum: 1
      WWW-Authenticate:
        description: >
          Challenge if the corresponding HTTP request has not provided
          authorization, or error details if the corresponding HTTP
          request has provided an invalid authorization token.
        type: string
        maximum: 1
        minimum: 0
    schema:
      $ref: "/../definitions/SOL002SOL003_def.yaml#/definitions/ProblemDetails"
  403:
    description: >
      If the API consumer is not allowed to perform a particular request
      to a particular resource, the API producer shall respond with this
      response code. The "ProblemDetails" structure shall be provided. 
      It should include in the "detail" attribute information about the
      source of the problem, and may indicate how to solve it.
    headers:
      Content-Type:
        description: The MIME type of the body of the response.
        type: string
        maximum: 1
        minimum: 1
      WWW-Authenticate:
        description: >
          Challenge if the corresponding HTTP request has not provided
          authorization, or error details if the corresponding HTTP
          request has provided an invalid authorization token.
        type: string
        maximum: 1
        minimum: 0
    schema:
      $ref: "/../definitions/SOL002SOL003_def.yaml#/definitions/ProblemDetails"
  404:
    description: >
      If the API producer did not find a current representation for the
      resource addressed by the URI passed in the request, or is not
      willing to disclose that one exists, it shall respond with this
      response code. 
      The "ProblemDetails" structure may be provided,
      including in the "detail" attribute information about the source
      of the problem, e.g. a wrong resource URI variable.
    headers:
      Content-Type:
        description: The MIME type of the body of the response.
        type: string
        maximum: 1
        minimum: 1
      WWW-Authenticate:
        description: >
          Challenge if the corresponding HTTP request has not provided
          authorization, or error details if the corresponding HTTP
          request has provided an invalid authorization token.
        type: string
        maximum: 1
        minimum: 0
    schema:
      $ref: "/../definitions/SOL002SOL003_def.yaml#/definitions/ProblemDetails"
  404-task-not-suported:
    description: >
      If the API producer did not find a current representation for the
      resource addressed by the URI passed in the request, or is not
      willing to disclose that one exists, it shall respond with this
      response code. 
      Specifically in case of this task resource, the reason can also be that
      the task is not supported for the VNF instance represented by the parent
      resource, and that the task resource consequently does not exist.
      The "ProblemDetails" structure may be provided, including in the
      "detail" attribute information about the sourceof the problem, e.g. a
      wrong resource URI variable.
    headers:
      Content-Type:
        description: The MIME type of the body of the response.
        type: string
        maximum: 1
        minimum: 1
      WWW-Authenticate:
        description: >
          Challenge if the corresponding HTTP request has not provided
          authorization, or error details if the corresponding HTTP
          request has provided an invalid authorization token.
        type: string
        maximum: 1
        minimum: 0
    schema:
      $ref: "/../definitions/SOL002SOL003_def.yaml#/definitions/ProblemDetails"
  404-task-not-suported-VNF-LCM:
    description: >
      If the API producer did not find a current representation for the
      resource addressed by the URI passed in the request, or is not
      willing to disclose that one exists, it shall respond with this
      response code. 
      Specifically in case of this task resource, the reason can also be that
      the task is not supported for the VNF LCM operation occurrence
      represented by the parent resource, and that the task resource
      consequently does not exist.
      The "ProblemDetails" structure may be provided, including in the
      "detail" attribute information about the sourceof the problem, e.g. a
      wrong resource URI variable.
    headers:
      Content-Type:
        description: The MIME type of the body of the response.
        type: string
        maximum: 1
        minimum: 1
      WWW-Authenticate:
        description: >
          Challenge if the corresponding HTTP request has not provided
          authorization, or error details if the corresponding HTTP
          request has provided an invalid authorization token.
        type: string
        maximum: 1
        minimum: 0
    schema:
      $ref: "../definitions/SOL002SOL003_def.yaml#/definitions/ProblemDetails"
  405:
    description: >
      If a particular HTTP method is not supported for a particular
      resource, the API producer shall respond with this response code.
      The "ProblemDetails" structure may be omitted in that case.
    headers:
      Content-Type:
        description: The MIME type of the body of the response.
        type: string
        maximum: 1
        minimum: 1
      WWW-Authenticate:
        description: >
          Challenge if the corresponding HTTP request has not provided
          authorization, or error details if the corresponding HTTP
          request has provided an invalid authorization token.
        type: string
        maximum: 1
        minimum: 0
    schema:
      $ref: "/../definitions/SOL002SOL003_def.yaml#/definitions/ProblemDetails"
  406:
    description: >
      If the "Accept" HTTP header does not contain at least one name of
      a content type that is acceptable to the API producer, the API
      producer shall respond with this response code. The
      "ProblemDetails" structure may be omitted in that case.        
    headers:
      Content-Type:
        description: The MIME type of the body of the response.
        type: string
        maximum: 1
        minimum: 1
      WWW-Authenticate:
        description: >
          Challenge if the corresponding HTTP request has not provided
          authorization, or error details if the corresponding HTTP
          request has provided an invalid authorization token.
        type: string
        maximum: 1
        minimum: 0
    schema:
      $ref: "/../definitions/SOL002SOL003_def.yaml#/definitions/ProblemDetails"
  412:
    description: >
      A precondition given in an HTTP request header is not fulfilled.
      Typically, this is due to an ETag mismatch, indicating that the
      resource was modified by another entity. The response body should
      contain a ProblemDetails structure, in which the "detail" attribute
      should convey more information about the error.
    headers:
      Content-Type:
        description: The MIME type of the body of the response.
        type: string
        maximum: 1
        minimum: 1
      WWW-Authenticate:
        description: >
          Challenge if the corresponding HTTP request has not provided
          authorization, or error details if the corresponding HTTP
          request has provided an invalid authorization token.
        type: string
        maximum: 1
        minimum: 0
    schema:
      $ref: "/../definitions/SOL002SOL003_def.yaml#/definitions/ProblemDetails"        
  416:
    description: >
      This code is returned if the requested byte range in the
      Range HTTP header is not present in the requested resource.
    headers:
      Content-Type:
        description: The MIME type of the body of the response.
        type: string
        maximum: 1
        minimum: 1
      WWW-Authenticate:
        description: >
          Challenge if the corresponding HTTP request has not provided
          authorization, or error details if the corresponding HTTP
          request has provided an invalid authorization token.
        type: string
        maximum: 1
        minimum: 0
    schema:
      $ref: "/../definitions/SOL002SOL003_def.yaml#/definitions/ProblemDetails"               
  422:
    description: >
      If the payload body of a request contains syntactically correct
      data (e.g. well-formed JSON) but the data cannot be processed
      (e.g. because it fails validation against a schema), the API
      producer shall respond with this response code. The
      "ProblemDetails" structure shall be provided, and should include
      in the "detail" attribute more information about the source of the
      problem.
      NOTE 2: This error response code is only applicable for methods
      that have a request body.
    headers:
      Content-Type:
        description: The MIME type of the body of the response.
        type: string
        maximum: 1
        minimum: 1
      WWW-Authenticate:
        description: >
          Challenge if the corresponding HTTP request has not provided
          authorization, or error details if the corresponding HTTP
          request has provided an invalid authorization token.
        type: string
        maximum: 1
        minimum: 0
    schema:
      $ref: "/../definitions/SOL002SOL003_def.yaml#/definitions/ProblemDetails"
  500:
    description: >
      If there is an application error not related to the client's input
      that cannot be easily mapped to any other HTTP response code
      ("catch all error"), the API producer shall respond withthis
      response code. The "ProblemDetails" structure shall be provided,
      and shall include in the "detail" attribute more information about
      the source of the problem.
    headers:
      Content-Type:
        description: The MIME type of the body of the response.
        type: string
        maximum: 1
        minimum: 1
      WWW-Authenticate:
        description: >
          Challenge if the corresponding HTTP request has not provided
          authorization, or error details if the corresponding HTTP
          request has provided an invalid authorization token.
        type: string
        maximum: 1
        minimum: 0
    schema:
      $ref: "/../definitions/SOL002SOL003_def.yaml#/definitions/ProblemDetails"
  503:
    description: >
      If the API producer encounters an internal overload situation of
      itself or of a system it relies on, it should respond with this
      response code, following the provisions in IETF RFC 7231 [13] for
      the use of the "Retry-After" HTTP header and for the alternative
      to refuse the connection. The "ProblemDetails" structure may be omitted.
    headers:
      Content-Type:
        description: The MIME type of the body of the response.
        type: string
        maximum: 1
        minimum: 1
      WWW-Authenticate:
        description: >
          Challenge if the corresponding HTTP request has not provided
          authorization, or error details if the corresponding HTTP
          request has provided an invalid authorization token.
        type: string
        maximum: 1
        minimum: 0
    schema:
      $ref: "/../definitions/SOL002SOL003_def.yaml#/definitions/ProblemDetails"
